#ifndef TEAM_H
#define TEAM_H

#include <vector>

#include "glm/vec3.hpp"

#include "coord.h"
#include "dude.h"
#include "behavior.h"

#define NB_STARTING_FOOD 5
#define SPAWN_COOLDOWN 30

class Team
{
    glm::vec3 m_teamColor;
    glm::vec3 m_dudeColor;
    int m_spawnCooldown;
    int m_foodQuantity;
    BehaviorFunction m_behavior;
public:
    Team(const glm::vec3 &spawnColor, const glm::vec3 &dudeColor, BehaviorFunction _behavior);
    bool updateSpawn();
    void addFood() {m_foodQuantity++; }
    void destroySpawn();
    Action* update(Dude);
};

#endif // TEAM_H
